﻿namespace StationProbe
{
    internal class DelayConfig
    {
        private static bool _isNight; 

        public static bool IsNight
        {
            get
            {
                var isNight = DateTime.Now.Hour >= 19 || DateTime.Now.Hour <= 7;
                if(_isNight != isNight)
                {
                    _isNight = isNight;
                    if(_isNight)
                    {
                        Task.Run(async () => 
                        {
                            try
                            {
                                await DingTalk.SendMessageAsync("Switch to night mode");
                            }
                            catch (Exception dx)
                            {
                                Logger.WriteLine($"Send dingtalk message error:{dx.Message}");
                            }
                        });
                    }
                    else
                    {
                        Task.Run(async () =>
                        {
                            try
                            {
                                await DingTalk.SendMessageAsync("Switch to normal mode");
                            }
                            catch (Exception dx)
                            {
                                Logger.WriteLine($"Send dingtalk message error:{dx.Message}");
                            }
                        });
                    }
                }
                return _isNight;
            }
        }

        public static int JumpDelay
        {
            get
            {
                if(IsNight)
                {
                    return 3000;
                }
                return 9000;
            }
        }

        public static int FilterDelay
        {
            get
            {
                if (IsNight)
                {
                    return 9000;
                }
                return 15000;
            }
        }

        public static int SaveImageDelay
        {
            get
            {
                if (IsNight)
                {
                    return 250;
                }
                return 500;
            }
        }

        public static int RetryDelay
        {
            get
            {
                if (IsNight)
                {
                    return 3000;
                }
                return 5000;
            }
        }


        public static int ExamContentDelay
        {
            get
            {
                if (IsNight)
                {
                    return 500;
                }
                return 1000;
            }
        }

        public static int KillChromeDelay
        {
            get
            {
                return 2000;
            }
        }

        public static int TaskDelay
        {
            get
            {
                if (IsNight)
                {
                    return 1000;
                }
                return 1500;
            }
        }
    }
}
