﻿using System;
using SQLite;

namespace StationProbe
{
    [Table("Images")]
    public class Image
    {
        [PrimaryKey]
        public string Id { get; set; } = string.Empty;

        [Indexed]
        public string ExamId { get; set; } = string.Empty;

        [Indexed]
        public int ImageIndex { get; set; }

        public byte[] Data { get; set; } = Array.Empty<byte>();

        public DateTime CreateTime { get; set; }
    }

    [Table("BatchTasks")]
    internal class BatchTask
    {
        [PrimaryKey, AutoIncrement]
        public int Id { get; set; }

        public string Name { get; set; } = string.Empty;

        public int PageCount { get; set; }

        public int ExamCount { get; set; }

        public DateTime Start { get; set; }

        public DateTime End { get; set; }

        public DateTime CreateTime { get; set; }

        public override string ToString()
        {
            return Name;
        }
    }


    [Table("Exams")]
    internal class Exam
    {
        [PrimaryKey]
        public string Id { get; set; } = string.Empty;

        public string PatientName { get; set; } = string.Empty;

        public int PatientAge { get; set; }

        public string PatientSex { get; set; } = string.Empty;

        public DateTime ExamDate { get; set; }

        public string Report { get; set; } = string.Empty;


        [Indexed]
        public int BatchTaskId { get; set; }

        [Indexed]
        public int ExamIndex { get; set; }

        [Indexed]
        public int PageIndex { get; set; }

        [Indexed]
        public int ExamIndexInPage { get; set; }

        public DateTime CreateTime { get; set; }

        public override string ToString()
        {
            return $"[{CreateTime}]#{PatientName}#{PatientSex}#{PatientAge}#{ExamDate}";
        }
    }
}
